# avis-client
VUE Autonomous Visual Inspection System (AVIS)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.8.0
- Package version: 0.8.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/vuengineering/public.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/vuengineering/public.git`)

Then import the package:
```python
import avis_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import avis_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import avis_client
from avis_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost:8000
# See configuration.py for a list of all supported configuration parameters.
configuration = avis_client.Configuration(
    host = "http://localhost:8000"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: cookieAuth
configuration.api_key['cookieAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['cookieAuth'] = 'Bearer'

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'


# Enter a context with an instance of the API client
with avis_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = avis_client.ApiKeysApi(api_client)
    user_api_key_create_request = avis_client.UserAPIKeyCreateRequest() # UserAPIKeyCreateRequest |  (optional)

    try:
        api_response = api_instance.keys_create(user_api_key_create_request=user_api_key_create_request)
        print("The response of ApiKeysApi->keys_create:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ApiKeysApi->keys_create: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:8000*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ApiKeysApi* | [**keys_create**](docs/ApiKeysApi.md#keys_create) | **POST** /api/keys/ | 
*ApiKeysApi* | [**keys_revoke_create**](docs/ApiKeysApi.md#keys_revoke_create) | **POST** /api/keys/revoke/ | 
*ConfigurationApi* | [**configuration_create**](docs/ConfigurationApi.md#configuration_create) | **POST** /api/configuration/ | 
*ConfigurationApi* | [**configuration_destroy**](docs/ConfigurationApi.md#configuration_destroy) | **DELETE** /api/configuration/{id}/ | 
*ConfigurationApi* | [**configuration_list**](docs/ConfigurationApi.md#configuration_list) | **GET** /api/configuration/ | 
*ConfigurationApi* | [**configuration_partial_update**](docs/ConfigurationApi.md#configuration_partial_update) | **PATCH** /api/configuration/{id}/ | 
*ConfigurationApi* | [**configuration_retrieve**](docs/ConfigurationApi.md#configuration_retrieve) | **GET** /api/configuration/{id}/ | 
*ConfigurationApi* | [**configuration_update**](docs/ConfigurationApi.md#configuration_update) | **PUT** /api/configuration/{id}/ | 
*ImageApi* | [**image_create**](docs/ImageApi.md#image_create) | **POST** /api/image/ | 
*ImageApi* | [**image_destroy**](docs/ImageApi.md#image_destroy) | **DELETE** /api/image/{id}/ | 
*ImageApi* | [**image_list**](docs/ImageApi.md#image_list) | **GET** /api/image/ | 
*ImageApi* | [**image_partial_update**](docs/ImageApi.md#image_partial_update) | **PATCH** /api/image/{id}/ | 
*ImageApi* | [**image_quality_list**](docs/ImageApi.md#image_quality_list) | **GET** /api/image/quality/ | 
*ImageApi* | [**image_retrieve**](docs/ImageApi.md#image_retrieve) | **GET** /api/image/{id}/ | 
*ImageApi* | [**image_update**](docs/ImageApi.md#image_update) | **PUT** /api/image/{id}/ | 
*ImageAttributeApi* | [**image_attribute_create**](docs/ImageAttributeApi.md#image_attribute_create) | **POST** /api/image-attribute/ | 
*ImageAttributeApi* | [**image_attribute_destroy**](docs/ImageAttributeApi.md#image_attribute_destroy) | **DELETE** /api/image-attribute/{id}/ | 
*ImageAttributeApi* | [**image_attribute_list**](docs/ImageAttributeApi.md#image_attribute_list) | **GET** /api/image-attribute/ | 
*ImageAttributeApi* | [**image_attribute_partial_update**](docs/ImageAttributeApi.md#image_attribute_partial_update) | **PATCH** /api/image-attribute/{id}/ | 
*ImageAttributeApi* | [**image_attribute_retrieve**](docs/ImageAttributeApi.md#image_attribute_retrieve) | **GET** /api/image-attribute/{id}/ | 
*ImageAttributeApi* | [**image_attribute_update**](docs/ImageAttributeApi.md#image_attribute_update) | **PUT** /api/image-attribute/{id}/ | 
*ImageAttributeCategoryApi* | [**image_attribute_category_create**](docs/ImageAttributeCategoryApi.md#image_attribute_category_create) | **POST** /api/image-attribute-category/ | 
*ImageAttributeCategoryApi* | [**image_attribute_category_destroy**](docs/ImageAttributeCategoryApi.md#image_attribute_category_destroy) | **DELETE** /api/image-attribute-category/{id}/ | 
*ImageAttributeCategoryApi* | [**image_attribute_category_list**](docs/ImageAttributeCategoryApi.md#image_attribute_category_list) | **GET** /api/image-attribute-category/ | 
*ImageAttributeCategoryApi* | [**image_attribute_category_partial_update**](docs/ImageAttributeCategoryApi.md#image_attribute_category_partial_update) | **PATCH** /api/image-attribute-category/{id}/ | 
*ImageAttributeCategoryApi* | [**image_attribute_category_retrieve**](docs/ImageAttributeCategoryApi.md#image_attribute_category_retrieve) | **GET** /api/image-attribute-category/{id}/ | 
*ImageAttributeCategoryApi* | [**image_attribute_category_update**](docs/ImageAttributeCategoryApi.md#image_attribute_category_update) | **PUT** /api/image-attribute-category/{id}/ | 
*InspectionApi* | [**inspection_create**](docs/InspectionApi.md#inspection_create) | **POST** /api/inspection/ | 
*InspectionApi* | [**inspection_destroy**](docs/InspectionApi.md#inspection_destroy) | **DELETE** /api/inspection/{id}/ | 
*InspectionApi* | [**inspection_list**](docs/InspectionApi.md#inspection_list) | **GET** /api/inspection/ | 
*InspectionApi* | [**inspection_partial_update**](docs/InspectionApi.md#inspection_partial_update) | **PATCH** /api/inspection/{id}/ | 
*InspectionApi* | [**inspection_retrieve**](docs/InspectionApi.md#inspection_retrieve) | **GET** /api/inspection/{id}/ | 
*InspectionApi* | [**inspection_send_validation_email_retrieve**](docs/InspectionApi.md#inspection_send_validation_email_retrieve) | **GET** /api/inspection/{id}/send_validation_email/ | 
*InspectionApi* | [**inspection_update**](docs/InspectionApi.md#inspection_update) | **PUT** /api/inspection/{id}/ | 
*InspectionApi* | [**inspection_validation_status_list**](docs/InspectionApi.md#inspection_validation_status_list) | **GET** /api/inspection/validation_status/ | 
*MembershipApi* | [**membership_create**](docs/MembershipApi.md#membership_create) | **POST** /api/membership/ | 
*MembershipApi* | [**membership_destroy**](docs/MembershipApi.md#membership_destroy) | **DELETE** /api/membership/{id}/ | 
*MembershipApi* | [**membership_list**](docs/MembershipApi.md#membership_list) | **GET** /api/membership/ | 
*MembershipApi* | [**membership_retrieve**](docs/MembershipApi.md#membership_retrieve) | **GET** /api/membership/{id}/ | 
*MembershipApi* | [**membership_update**](docs/MembershipApi.md#membership_update) | **PUT** /api/membership/{id}/ | 
*MetadataApi* | [**metadata_create**](docs/MetadataApi.md#metadata_create) | **POST** /api/metadata/ | 
*MetadataApi* | [**metadata_destroy**](docs/MetadataApi.md#metadata_destroy) | **DELETE** /api/metadata/{id}/ | 
*MetadataApi* | [**metadata_list**](docs/MetadataApi.md#metadata_list) | **GET** /api/metadata/ | 
*MetadataApi* | [**metadata_partial_update**](docs/MetadataApi.md#metadata_partial_update) | **PATCH** /api/metadata/{id}/ | 
*MetadataApi* | [**metadata_retrieve**](docs/MetadataApi.md#metadata_retrieve) | **GET** /api/metadata/{id}/ | 
*MetadataApi* | [**metadata_update**](docs/MetadataApi.md#metadata_update) | **PUT** /api/metadata/{id}/ | 
*MetadataSchemaApi* | [**metadata_schema_create**](docs/MetadataSchemaApi.md#metadata_schema_create) | **POST** /api/metadata-schema/ | 
*MetadataSchemaApi* | [**metadata_schema_destroy**](docs/MetadataSchemaApi.md#metadata_schema_destroy) | **DELETE** /api/metadata-schema/{id}/ | 
*MetadataSchemaApi* | [**metadata_schema_list**](docs/MetadataSchemaApi.md#metadata_schema_list) | **GET** /api/metadata-schema/ | 
*MetadataSchemaApi* | [**metadata_schema_partial_update**](docs/MetadataSchemaApi.md#metadata_schema_partial_update) | **PATCH** /api/metadata-schema/{id}/ | 
*MetadataSchemaApi* | [**metadata_schema_retrieve**](docs/MetadataSchemaApi.md#metadata_schema_retrieve) | **GET** /api/metadata-schema/{id}/ | 
*MetadataSchemaApi* | [**metadata_schema_update**](docs/MetadataSchemaApi.md#metadata_schema_update) | **PUT** /api/metadata-schema/{id}/ | 
*MlApi* | [**ml_model_create**](docs/MlApi.md#ml_model_create) | **POST** /api/ml/model/ | 
*MlApi* | [**ml_model_destroy**](docs/MlApi.md#ml_model_destroy) | **DELETE** /api/ml/model/{id}/ | 
*MlApi* | [**ml_model_inference**](docs/MlApi.md#ml_model_inference) | **POST** /api/ml/model/{id}/infer/ | 
*MlApi* | [**ml_model_list**](docs/MlApi.md#ml_model_list) | **GET** /api/ml/model/ | 
*MlApi* | [**ml_model_partial_update**](docs/MlApi.md#ml_model_partial_update) | **PATCH** /api/ml/model/{id}/ | 
*MlApi* | [**ml_model_retrieve**](docs/MlApi.md#ml_model_retrieve) | **GET** /api/ml/model/{id}/ | 
*MlApi* | [**ml_model_type_create**](docs/MlApi.md#ml_model_type_create) | **POST** /api/ml/model-type/ | 
*MlApi* | [**ml_model_type_destroy**](docs/MlApi.md#ml_model_type_destroy) | **DELETE** /api/ml/model-type/{id}/ | 
*MlApi* | [**ml_model_type_list**](docs/MlApi.md#ml_model_type_list) | **GET** /api/ml/model-type/ | 
*MlApi* | [**ml_model_type_partial_update**](docs/MlApi.md#ml_model_type_partial_update) | **PATCH** /api/ml/model-type/{id}/ | 
*MlApi* | [**ml_model_type_retrieve**](docs/MlApi.md#ml_model_type_retrieve) | **GET** /api/ml/model-type/{id}/ | 
*MlApi* | [**ml_model_type_update**](docs/MlApi.md#ml_model_type_update) | **PUT** /api/ml/model-type/{id}/ | 
*MlApi* | [**ml_model_update**](docs/MlApi.md#ml_model_update) | **PUT** /api/ml/model/{id}/ | 
*ProductApi* | [**product_create**](docs/ProductApi.md#product_create) | **POST** /api/product/ | 
*ProductApi* | [**product_destroy**](docs/ProductApi.md#product_destroy) | **DELETE** /api/product/{id}/ | 
*ProductApi* | [**product_list**](docs/ProductApi.md#product_list) | **GET** /api/product/ | 
*ProductApi* | [**product_partial_update**](docs/ProductApi.md#product_partial_update) | **PATCH** /api/product/{id}/ | 
*ProductApi* | [**product_retrieve**](docs/ProductApi.md#product_retrieve) | **GET** /api/product/{id}/ | 
*ProductApi* | [**product_update**](docs/ProductApi.md#product_update) | **PUT** /api/product/{id}/ | 
*ProductCategoryApi* | [**product_category_create**](docs/ProductCategoryApi.md#product_category_create) | **POST** /api/product-category/ | 
*ProductCategoryApi* | [**product_category_destroy**](docs/ProductCategoryApi.md#product_category_destroy) | **DELETE** /api/product-category/{id}/ | 
*ProductCategoryApi* | [**product_category_list**](docs/ProductCategoryApi.md#product_category_list) | **GET** /api/product-category/ | 
*ProductCategoryApi* | [**product_category_partial_update**](docs/ProductCategoryApi.md#product_category_partial_update) | **PATCH** /api/product-category/{id}/ | 
*ProductCategoryApi* | [**product_category_retrieve**](docs/ProductCategoryApi.md#product_category_retrieve) | **GET** /api/product-category/{id}/ | 
*ProductCategoryApi* | [**product_category_update**](docs/ProductCategoryApi.md#product_category_update) | **PUT** /api/product-category/{id}/ | 
*QualityCriteriaApi* | [**quality_criteria_create**](docs/QualityCriteriaApi.md#quality_criteria_create) | **POST** /api/quality-criteria/ | 
*QualityCriteriaApi* | [**quality_criteria_destroy**](docs/QualityCriteriaApi.md#quality_criteria_destroy) | **DELETE** /api/quality-criteria/{id}/ | 
*QualityCriteriaApi* | [**quality_criteria_list**](docs/QualityCriteriaApi.md#quality_criteria_list) | **GET** /api/quality-criteria/ | 
*QualityCriteriaApi* | [**quality_criteria_partial_update**](docs/QualityCriteriaApi.md#quality_criteria_partial_update) | **PATCH** /api/quality-criteria/{id}/ | 
*QualityCriteriaApi* | [**quality_criteria_retrieve**](docs/QualityCriteriaApi.md#quality_criteria_retrieve) | **GET** /api/quality-criteria/{id}/ | 
*QualityCriteriaApi* | [**quality_criteria_update**](docs/QualityCriteriaApi.md#quality_criteria_update) | **PUT** /api/quality-criteria/{id}/ | 
*ResultApi* | [**result_create**](docs/ResultApi.md#result_create) | **POST** /api/result/ | 
*ResultApi* | [**result_destroy**](docs/ResultApi.md#result_destroy) | **DELETE** /api/result/{id}/ | 
*ResultApi* | [**result_list**](docs/ResultApi.md#result_list) | **GET** /api/result/ | 
*ResultApi* | [**result_partial_update**](docs/ResultApi.md#result_partial_update) | **PATCH** /api/result/{id}/ | 
*ResultApi* | [**result_retrieve**](docs/ResultApi.md#result_retrieve) | **GET** /api/result/{id}/ | 
*ResultApi* | [**result_update**](docs/ResultApi.md#result_update) | **PUT** /api/result/{id}/ | 
*StatisticsApi* | [**statistics_configuration_create**](docs/StatisticsApi.md#statistics_configuration_create) | **POST** /api/statistics/configuration/ | 
*StatisticsApi* | [**statistics_configuration_destroy**](docs/StatisticsApi.md#statistics_configuration_destroy) | **DELETE** /api/statistics/configuration/{id}/ | 
*StatisticsApi* | [**statistics_configuration_list**](docs/StatisticsApi.md#statistics_configuration_list) | **GET** /api/statistics/configuration/ | 
*StatisticsApi* | [**statistics_configuration_retrieve**](docs/StatisticsApi.md#statistics_configuration_retrieve) | **GET** /api/statistics/configuration/{id}/ | 
*StatisticsApi* | [**statistics_configuration_update**](docs/StatisticsApi.md#statistics_configuration_update) | **PUT** /api/statistics/configuration/{id}/ | 
*StatisticsApi* | [**statistics_inspection_create**](docs/StatisticsApi.md#statistics_inspection_create) | **POST** /api/statistics/inspection/ | 
*StatisticsApi* | [**statistics_inspection_destroy**](docs/StatisticsApi.md#statistics_inspection_destroy) | **DELETE** /api/statistics/inspection/{id}/ | 
*StatisticsApi* | [**statistics_inspection_list**](docs/StatisticsApi.md#statistics_inspection_list) | **GET** /api/statistics/inspection/ | 
*StatisticsApi* | [**statistics_inspection_retrieve**](docs/StatisticsApi.md#statistics_inspection_retrieve) | **GET** /api/statistics/inspection/{id}/ | 
*StatisticsApi* | [**statistics_inspection_update**](docs/StatisticsApi.md#statistics_inspection_update) | **PUT** /api/statistics/inspection/{id}/ | 
*StatisticsApi* | [**statistics_team_create**](docs/StatisticsApi.md#statistics_team_create) | **POST** /api/statistics/team/ | 
*StatisticsApi* | [**statistics_team_destroy**](docs/StatisticsApi.md#statistics_team_destroy) | **DELETE** /api/statistics/team/{id}/ | 
*StatisticsApi* | [**statistics_team_list**](docs/StatisticsApi.md#statistics_team_list) | **GET** /api/statistics/team/ | 
*StatisticsApi* | [**statistics_team_retrieve**](docs/StatisticsApi.md#statistics_team_retrieve) | **GET** /api/statistics/team/{id}/ | 
*StatisticsApi* | [**statistics_team_update**](docs/StatisticsApi.md#statistics_team_update) | **PUT** /api/statistics/team/{id}/ | 
*TeamsApi* | [**teams_create**](docs/TeamsApi.md#teams_create) | **POST** /api/teams/ | 
*TeamsApi* | [**teams_destroy**](docs/TeamsApi.md#teams_destroy) | **DELETE** /api/teams/{id}/ | 
*TeamsApi* | [**teams_list**](docs/TeamsApi.md#teams_list) | **GET** /api/teams/ | 
*TeamsApi* | [**teams_retrieve**](docs/TeamsApi.md#teams_retrieve) | **GET** /api/teams/{id}/ | 
*TeamsApi* | [**teams_update**](docs/TeamsApi.md#teams_update) | **PUT** /api/teams/{id}/ | 
*UserApi* | [**user_email_list**](docs/UserApi.md#user_email_list) | **GET** /api/user/email/ | 
*UserApi* | [**user_whoami_retrieve**](docs/UserApi.md#user_whoami_retrieve) | **GET** /api/user/whoami/ | 


## Documentation For Models

 - [AzureMLInferenceRequest](docs/AzureMLInferenceRequest.md)
 - [BlankEnum](docs/BlankEnum.md)
 - [ConfigurationStatistics](docs/ConfigurationStatistics.md)
 - [ConfigurationStatisticsRequest](docs/ConfigurationStatisticsRequest.md)
 - [ConfigurationType](docs/ConfigurationType.md)
 - [ConfigurationTypeRequest](docs/ConfigurationTypeRequest.md)
 - [CustomUser](docs/CustomUser.md)
 - [CustomUserRequest](docs/CustomUserRequest.md)
 - [EmailAddress](docs/EmailAddress.md)
 - [FormatEnum](docs/FormatEnum.md)
 - [Image](docs/Image.md)
 - [ImageAttribute](docs/ImageAttribute.md)
 - [ImageAttributeCategory](docs/ImageAttributeCategory.md)
 - [ImageAttributeCategoryRequest](docs/ImageAttributeCategoryRequest.md)
 - [ImageAttributeRequest](docs/ImageAttributeRequest.md)
 - [ImageRequest](docs/ImageRequest.md)
 - [Inspection](docs/Inspection.md)
 - [InspectionImagesStatistics](docs/InspectionImagesStatistics.md)
 - [InspectionImagesStatisticsRequest](docs/InspectionImagesStatisticsRequest.md)
 - [InspectionRequest](docs/InspectionRequest.md)
 - [InspectionStatistics](docs/InspectionStatistics.md)
 - [InspectionStatisticsRequest](docs/InspectionStatisticsRequest.md)
 - [InspectionValidationStatus](docs/InspectionValidationStatus.md)
 - [MLModel](docs/MLModel.md)
 - [MLModelRequest](docs/MLModelRequest.md)
 - [MLModelType](docs/MLModelType.md)
 - [MLModelTypeRequest](docs/MLModelTypeRequest.md)
 - [Membership](docs/Membership.md)
 - [MembershipRequest](docs/MembershipRequest.md)
 - [Metadata](docs/Metadata.md)
 - [MetadataRequest](docs/MetadataRequest.md)
 - [MetadataSchema](docs/MetadataSchema.md)
 - [MetadataSchemaRequest](docs/MetadataSchemaRequest.md)
 - [PaginatedConfigurationStatisticsList](docs/PaginatedConfigurationStatisticsList.md)
 - [PaginatedConfigurationTypeList](docs/PaginatedConfigurationTypeList.md)
 - [PaginatedImageAttributeCategoryList](docs/PaginatedImageAttributeCategoryList.md)
 - [PaginatedImageAttributeList](docs/PaginatedImageAttributeList.md)
 - [PaginatedImageList](docs/PaginatedImageList.md)
 - [PaginatedInspectionImagesStatisticsList](docs/PaginatedInspectionImagesStatisticsList.md)
 - [PaginatedInspectionList](docs/PaginatedInspectionList.md)
 - [PaginatedInspectionStatisticsList](docs/PaginatedInspectionStatisticsList.md)
 - [PaginatedInspectionValidationStatusList](docs/PaginatedInspectionValidationStatusList.md)
 - [PaginatedMLModelList](docs/PaginatedMLModelList.md)
 - [PaginatedMLModelTypeList](docs/PaginatedMLModelTypeList.md)
 - [PaginatedMembershipList](docs/PaginatedMembershipList.md)
 - [PaginatedMetadataList](docs/PaginatedMetadataList.md)
 - [PaginatedMetadataSchemaList](docs/PaginatedMetadataSchemaList.md)
 - [PaginatedProductCategoryList](docs/PaginatedProductCategoryList.md)
 - [PaginatedProductList](docs/PaginatedProductList.md)
 - [PaginatedQualityCriteriaList](docs/PaginatedQualityCriteriaList.md)
 - [PaginatedQualityCriteriaResultList](docs/PaginatedQualityCriteriaResultList.md)
 - [PaginatedResultList](docs/PaginatedResultList.md)
 - [PaginatedTeamList](docs/PaginatedTeamList.md)
 - [PatchedConfigurationTypeRequest](docs/PatchedConfigurationTypeRequest.md)
 - [PatchedImageAttributeCategoryRequest](docs/PatchedImageAttributeCategoryRequest.md)
 - [PatchedImageAttributeRequest](docs/PatchedImageAttributeRequest.md)
 - [PatchedImageRequest](docs/PatchedImageRequest.md)
 - [PatchedInspectionRequest](docs/PatchedInspectionRequest.md)
 - [PatchedMLModelRequest](docs/PatchedMLModelRequest.md)
 - [PatchedMLModelTypeRequest](docs/PatchedMLModelTypeRequest.md)
 - [PatchedMetadataRequest](docs/PatchedMetadataRequest.md)
 - [PatchedMetadataSchemaRequest](docs/PatchedMetadataSchemaRequest.md)
 - [PatchedProductCategoryRequest](docs/PatchedProductCategoryRequest.md)
 - [PatchedProductRequest](docs/PatchedProductRequest.md)
 - [PatchedQualityCriteriaRequest](docs/PatchedQualityCriteriaRequest.md)
 - [PatchedResultRequest](docs/PatchedResultRequest.md)
 - [PatchedResultRequestStatus](docs/PatchedResultRequestStatus.md)
 - [Product](docs/Product.md)
 - [ProductCategory](docs/ProductCategory.md)
 - [ProductCategoryRequest](docs/ProductCategoryRequest.md)
 - [ProductRequest](docs/ProductRequest.md)
 - [QualityCriteria](docs/QualityCriteria.md)
 - [QualityCriteriaRequest](docs/QualityCriteriaRequest.md)
 - [QualityCriteriaResult](docs/QualityCriteriaResult.md)
 - [QualityEnum](docs/QualityEnum.md)
 - [Result](docs/Result.md)
 - [ResultRequest](docs/ResultRequest.md)
 - [StatusEnum](docs/StatusEnum.md)
 - [Team](docs/Team.md)
 - [TeamRequest](docs/TeamRequest.md)
 - [UserAPIKeyCreate](docs/UserAPIKeyCreate.md)
 - [UserAPIKeyCreateRequest](docs/UserAPIKeyCreateRequest.md)
 - [ValidationStatusEnum](docs/ValidationStatusEnum.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="ApiKeyAuth"></a>
### ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-Api-Key
- **Location**: HTTP header

<a id="cookieAuth"></a>
### cookieAuth

- **Type**: API key
- **API key parameter name**: sessionid
- **Location**: 


## Author




